B=0.05*[0;0;1];
E=2000*[1;0;0];

e=1.6e-19;
m=9.1e-31;

% initial conditions:
r0=[0;0;0];
V0=100000*[1;0;0.3];

tm=1e-8;
dt=tm/10000;
ts=0:dt:tm;


R=zeros(6,length(ts));



Rc=1;

for t=ts
    if Rc~=1
        V=R(4:6,Rc-1);
        F=e*(E+cross(V,B));
        R(:,Rc)=R(:,Rc-1)+([V;F/m])*dt;
    else
        R(:,Rc)=[r0;V0];
    end
    Rc=Rc+1;
end

% plot3(R(1,:),R(2,:),R(3,:))
% axis equal

figure;
hpar=axes;
set(hpar,'units','normalized');
set(hpar,'position',[0.05 0.05 0.9 0.9]);
%zoom(10);
hold on;
axis equal;
light;
view(116,32);
xlabel('X');
ylabel('Y');
zlabel('Z');
pa=[0;1e-4;0];
sc=1e-4;
xlim([-3*sc 3*sc]);
ylim([-5*sc 1*sc]);
zlim([-1*sc 4*sc]);
En=sqrt(E(1)^2+E(2)^2+E(3)^2);
Bn=sqrt(B(1)^2+B(2)^2+B(3)^2);
%arrow(x,y,z,vx,vy,vz,th,lr,c,hpar)
arrow(pa(1),pa(2),pa(3),(E(1)/En)*sc,(E(2)/En)*sc,(E(3)/En)*sc,0.2*sc,0.01*sc,[1 0 0],hpar);
text(pa(1)+(E(1)/En)*sc*1.2,pa(2)+(E(2)/En)*sc*1.2,pa(3)+(E(3)/En)*sc*1.2,'E');
arrow(pa(1),pa(2),pa(3),(B(1)/Bn)*sc,(B(2)/Bn)*sc,(B(3)/Bn)*sc,0.2*sc,0.01*sc,[0 0 1],hpar);
text(pa(1)+(B(1)/Bn)*sc*1.2,pa(2)+(B(2)/Bn)*sc*1.2,pa(3)+(B(3)/Bn)*sc*1.2,'B');

ac=10;
ts1=0:dt*ac:tm/2;
pth=plot3(R(1,1),R(2,1),R(3,1),'r-');
hs=sphereic(0,0,0,1e-5,[1 1 0],1,hpar);
Xs=get(hs,'XData');
Ys=get(hs,'YData');
Zs=get(hs,'ZData');
lc=1;
lc0=1;
for t=ts1
    set(pth,'XData',R(1,1:lc),'YData',R(2,1:lc),'ZData',R(3,1:lc));
    set(hs,'XData',Xs+R(1,lc),'YData',Ys+R(2,lc),'ZData',Zs+R(3,lc));
    %view(116-60*t/tm,22+100*t/tm);
    %camorbit(0.06,0.1);
    drawnow;
    lc=lc+ac;
    %M(lc0)=getframe;
    lc0=lc0+1;
end

%movie2avi(M,'electron5','fps',25,'compression','Cinepak');
    